\section{Conclusion}
\label{sec:conclusion}

The development of this work derived in practical experience with C++. Our key
learnings can be separated depending on the implementation section:

\nameref{subsec:appUI}: FLUID as a code generating tool for User Interfaces.
Its usage is simple although it is not very intuitive. It is closer to visual
programming tool than to a UI designer. Once you take that into account, you
can really take advantage of it.

\nameref{subsec:app}: Static functions for callbacks that need to receive a
pointer to the application object in order to have access to the application
data. Static casting
(\href{https://en.cppreference.com/w/cpp/language/static_cast}{\texttt{std::static\_cast}})
of the callback input from a void pointer into a pointer
to the application object.

\nameref{subsec:AV_input}: Thread synchronization mechanisms
(\href{https://en.cppreference.com/w/cpp/container/queue}{\texttt{std::queue}},
\href{https://en.cppreference.com/w/cpp/thread/mutex}{\texttt{std::mutex}},
\href{https://en.cppreference.com/w/cpp/thread/condition_variable}{\texttt{std::condition\_variable}}).
They make C++ a powerful language but they must be handled with care. It is
very easy to fall into deadlocks and race conditions. \href{https://en.cppreference.com/w/cpp/language/nested_types}{Nested}
and
\href{https://en.cppreference.com/w/cpp/language/nested_types}{derived}
classes make your code truly Object Oriented. Learning how to handled them let
us make our code shorter, clearer and less buggy. Although we could have made a
better use of them taking them into account from the design stage. 

\nameref{subsec:processors}:
\href{https://en.cppreference.com/w/cpp/language/namespace}{Namespaces} 
avoid name clashing and allow easily extendible modularization, future projects
will make a bigger use of them as it is becoming the standard way to enclose a
library. Function factories are a design pattern that allows the creation of
functions during the code execution. They are almost necessary in some
situations.
\href{https://en.cppreference.com/w/cpp/language/lambda}{Lambdas} are ways to
define unnamed functions which can be very useful depending on the situation.
Usually combined with function factories in order to wrap functions and adapt
call signatures in a clear and readable way.

The learnings and source code implemented will be of use for the implementation
of the master thesis research of the authors. However, there are still many
challenges that we will need to overcome. First and most important, the
application should be more robust and stable. Then, there are a list of desired
features:
\begin{itemize}
    \item The \FLTK \OpenCV integration is not complete. We succeeded in
    showing an OpenCV matrix in an FLTK widget but we failed to handle FLTK
    mouse interaction as OpenCV does. In a future version we would like to be
    able to zoom on the image by clicking it. 
    \item Separate files for audio and video. The \nameref{subsec:AV_input} has
    ben developed taking into account that the audio and video streams could
    come from different files (or devices), but we have not been able to test
    and finalize this feature in time.
    \item Sound output through the speakers. Audio data is processed and
    visualized but we have not implemented a sound output. Doing so would
    require using another library (\href{https://www.libsdl.org/}{Simple
    Directmedia Layer} for example) and synchronizing the sound output with the
    display of images.
    \item Ability to correct the synchronization of the video and audio streams
    using user input. In the case that audio and video streams come from
    different files, it is probable that the synchronization is not correct.
    An adjusting interface should be possible. Ideally the corrected video
    could be saved to a file.
\end{itemize}